//constants.c
// this file is about the use of different types of constants, and how to display values with scientific notation (i.e: 1.7 x 10^-2)

#include <stdio.h>

void constants()
{

	printf("\n%-50s\n","-----constants\n");
	char number1 = 100; // 0x64, 0b01100100
	char number2 = -100; //0x9c, 0b10011100
	// regarding 16,32 bit registers
	// 0x9c can be 0xff9c 0xffffff9c

	printf("%d\n", number1);	//	100
	printf("%o\n", number1); 	//	144
	printf("%x\n", number1);	//	64

	printf("%d\n", number2); 	//	-100
	printf("%x\n", number2); 	//	ffffff9c

	printf("%c\n",48); 	//0   ASCII characters
	printf("%c\n",65); 	//A
	printf("%c\n",97); 	//a
	printf("%c\n",179); //│
	printf("%c\n",225); //ß

	//	-15000		(signed) int constant
	//	15000U		(unsigned) int constant.
	//	1200L		(signed) long constant
	//	1200Lu		(unsigned) long constant.

	//	123ul, 123UL, 123Lu, 123lu all the same

	//	0x12			hex rep.  (int) constant.
	//	0X12L			hex rep.  long int constant.
	//	0x1934ul		hex rep.  unsigned long int  constant.
	//	01234			octal rep. int constant
	//	0567L			octal rep. long int constant
	//	0777U			octal rep. unsigned int constant
	//	0452Lu			octal rep. unsigned long int constant.

	//	1.31F
	//	10.F
	//	-2.456f
	// float constants

	//	-24.5 double constant
	//	1.34L long double constant
	//	10.2L long double constant

	//	2.3e+04f scientific format for floating point constant
	//	1.74e-6F scientific format for floating point constant
	//	8.e+9f	scientific format for floating point constant

	//	1.34E-2f == 0.0134
	//	-1.2E+2F == 120.f

	printf("%u\n" ,1234u);  // unsigned integer
	printf("%d\n" ,1234);   // signed integer
	printf("%i\n" ,1234);   // signed integer
	printf("%ld\n", 1234L); // signed long integer
	printf("%li\n", 1234L); // signed long integer
	printf("%lu\n", 1234L); // unsigned long integer
	//	1234
	//	1234
	//	1234
	//	1234
	//	1234
	//	1234

	printf("%Lf\n",1.2345678L); // long double
	printf("%lf\n",1.2345678);  // double
	printf("%f\n" ,1.2345678f); // float
	//	1.234568
	//	1.234568
	//	1.234568

	printf("%e\n", 1.2345678e-2f); // scientific notation
	printf("%E\n", 1.2345678e-2f);
	printf("%g\n", 1.2345678e-2f);
	printf("%G\n", 1.2345678e-2f);
	//	1.234568e-02
	//	1.234568E-02
	//	0.0123457
	//	0.0123457
	//  	with G or g format specifier compiler
	//  	decides whether to use fixed or scientific notation
	//       %g will take a number that could be represented as %f
	//      (a simple float or double) or %e (scientific notation)
	//      and return it as the shorter of the two.


	// very small numbers
	printf("%e\n", 1.2345678e-9f);
	printf("%E\n", 1.2345678e-9f);
	printf("%g\n", 1.2345678e-9f);
	printf("%G\n", 1.2345678e-9f);
	//	1.234568e-09
	//	1.234568E-09
	//	1.23457e-09
	//	1.23457E-09

	// very large numbers
	printf("%e\n", 1.2345678e+9);
	printf("%E\n", 1.2345678e+9f);
	printf("%g\n", 1.2345678e+9f);
	printf("%G\n", 1.2345678e+9f);
	//	1.234568e+09
	//	1.234568E+09
	//	1.23457e+09
	//	1.23457E+09

	printf("%s\n", "this is a C course");

}
