// floating_values.c
// this file is about how to represent floating values in computers
#include <stdio.h>

void floating_values()
{
	printf("\n-----floating_values\n");
	float number = -1.3501e-015;

	printf("%25.20f\n",-1.3501e-015);
	printf("%25.20f\n",3.501e-016);
	printf("%25.20f\n",1e-015);

	if (number + (3.501e-016 +1e-015) == 0)
		printf("floating point representations are precise");
	else
		printf("floating point representations are not precise");

}

//NOTES***************************************//

/*
i.e 4 byte representation:
32 bits will be separated to three parts

1.sign bit  (1 bit) S
	1 for negative numbers, 0 for positive numbers
2. exponent) (8 bit)  EEEEEEEE
3. fraction) (23 bit) FFFFFFFFFFFFFFFFFFFFFFF

S	EEEEEEEE		FFFFFFFFFFFFFFFFFFFFFFF
31	30-----------23		22-------------------------------------0

If E = 255 and F is a non-zero value, then V is NaN (Not a Number) and is not considered a real number. Example:

0 11111111 00001000000100000000000 = Not a number
1 11111111 00010101010001001010101 = Not a number

If E = 255, F = 0, and S = 1, then V = -infinity
If E = 255, F = 0, and S = 0, then V = +infinity

If 0 < E < 255, then...
V = (-1)^S * 2^(E - 127) * (1.F)

First, add "1." to the beginning of the fraction part of the number. Then, multiply this number by 2^(E - 127) to adjust the decimal point's position. The portion after the decimal point is obtained by multiplying by the increasing negative powers of 2. Examples:

0 10000000 00000000000000000000000 	= +1 * 2^(128 - 127) * 1.0
       								= 2 * (1.0)_2
       								= 2

1 10000001 10100000000000000000000 	= -1 * 2 (129 - 127)  * 1.101
									= -2^2 * (1.101)_2
									= -4(1+1/2+1/8)
									= -6.5
*/
