//functions_io.c
// this file is about character input output functions

#include <stdio.h>
#include <conio.h>

void functions_io()
{
	printf("\n-----functions_io\n");
	printf("Functions to receive character input from the keyboard, other than scanf()\n");
	char ch;

	printf("\nenter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:\n");
	ch = getchar(); //int getchar(void)
	// there is a need to press enter. the character is displayed upon entering.

	printf("...character is %c and the ASCII number is %d\n", ch, ch);
	//	enter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:
	//	p
	//	...character is p and the ASCII number is 112


	printf("\nenter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:\n");
	ch = getch(); //int getch(void)
	//(getch() is a non-standard func. which is present in the file of conio.h. !)
	// no need to press enter, the character is not displayed upon entering.

	printf("...character is %c and the ASCII number is %d\n", ch, ch);
	//	enter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:
	//	...character is p and the ASCII number is 112


	printf("\nenter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:\n");
	ch = getche(); //int getche(void)
		//(getche() is a non-standard func. which is present in the file of conio.h. !)
	// no need to press enter, the character is displayed upon entering.

	printf("...character is %c and the ASCII number is %d\n", ch, ch);
	//	enter an alphanumeric character using keyboard {a-z, A-Z, 0-9}:
	//	p...character is p and the ASCII number is 112




	printf("Functions to display characters as output on the screen, other than printf() \n");

	putchar(ch);  	//int putchar(int ch)
	putch(ch);  	//void putch(int ch)

	// putchar(): This function is used to print one character on the screen,
	// and this may be any character from C characterset
	// (i.e it may be printable or non printable characters).
	// putchar() return a value.

	// putch(): The putch() function is used to display all alphanumeric characters
	// throught the standard output device like monitor.
	// this function display single character at a time.
	// putch() does not return a value.
	// Non-Standard Function, putch() is not part of the C standard library.

}

//NOTES***************************************//

/*
getchar:	Requires pressing the Enter key; 			the character received is visible on the screen.
getch: 		Does not require pressing the Enter key; 	the character received is not visible on the screen.
getche: 	Does not require pressing the Enter key; 	the character received is visible on the screen.
*/
