// io_formats.c
// this  file includes the max-min values of the ranges for different data types also printf() functions' format specifier list
// check also types.c, printf_scanf.c, constants.c

#include <stdio.h>
#include <limits.h> //this header file has limit information of built in types

void io_formats()
{

	printf("\n-----io_formats\n");
	printf("%x\n%d\n",0x1C205470, 0x1C205470 );
	printf("%ll\n",sizeof(0x1C205470));

	printf("The value of CHAR_BIT: %d\n", CHAR_BIT);
	printf("The value of SCHAR_MIN: %d\n", SCHAR_MIN);
	printf("The value of SCHAR_MAX: %d\n", SCHAR_MAX);
	printf("The value of UCHAR_MAX: %u\n", UCHAR_MAX);
	printf("The value of CHAR_MIN: %d\n", CHAR_MIN);
	printf("The value of CHAR_MAX: %d\n", CHAR_MAX);
	printf("The value of MB_LEN_MAX: %d\n", MB_LEN_MAX);
	printf("The value of SHRT_MIN: %d\n", SHRT_MIN);
	printf("The value of SHRT_MAX: %d\n", SHRT_MAX);
	printf("The value of USHRT_MAX: %u\n", USHRT_MAX);
	printf("The value of INT_MIN: %d\n", INT_MIN);
	printf("The value of INT_MAX: %d\n", INT_MAX);
	printf("The value of UINT_MAX: %u\n", UINT_MAX);
	printf("The value of LONG_MIN: %ld\n", LONG_MIN);
	printf("The value of LONG_MAX: %ld\n", LONG_MAX);
	printf("The value of ULONG_MAX: %lu\n", ULONG_MAX);

	//	The value of CHAR_BIT: 8
	//	The value of SCHAR_MIN: -128
	//	The value of SCHAR_MAX: 127
	//	The value of UCHAR_MAX: 255
	//	The value of CHAR_MIN: -128
	//	The value of CHAR_MAX: 127
	//	The value of MB_LEN_MAX: 5
	//	The value of SHRT_MIN: -32768
	//	The value of SHRT_MAX: 32767
	//	The value of USHRT_MAX: 65535
	//	The value of INT_MIN: -2147483648
	//	The value of INT_MAX: 2147483647
	//	The value of UINT_MAX: 4294967295
	//	The value of LONG_MIN: -2147483648
	//	The value of LONG_MAX: 2147483647
	//	The value of ULONG_MAX: 4294967295

	// or is long int is represented with 8 bits

	//	The value of LONG_MIN: -9223372036854775808
	//	The value of LONG_MAX: 9223372036854775807
	//	The value of ULONG_MAX: 18446744073709551615

	printf("%d\n", sizeof(char)); 	//1
	printf("%d\n", sizeof(short));	//2
	printf("%d\n", sizeof(int));	//2
	printf("%d\n", sizeof(long));   //4 (for my computer)
	printf("%d\n", sizeof(float));  //4
	printf("%d\n", sizeof(double)); //8
	printf("%d\n", sizeof(long double)); //16
}



// %c    		For character type.
// %d			For signed integer type.
// %e or %E		For scientific notation of floats.
// %f			For float type.
// %g or %G		For float type with the current precision.
// %i			signed integer
// %ld or %li   Long integer
// %lf			Double
// %Lf			Long double
//	%lu			Unsigned int or unsigned long
// %lli or %lld	Long long
// %llu			Unsigned long long
// %o			Octal representation
// %p			Pointer
// %s			String
// %u 			Unsigned int
// %x or %X		Hexadecimal representation
// %n			Prints nothing
// %% 			Prints % character
