// printf_scanf.c
// this file is about printing different type of values, associated with format specifiers

void printf_scanf()
{
	printf("\n-----printf_scanf\n");
	int x;
	float y;

	x = 125;
	y = 200.0f;
	printf("x = %d\ny = %f\n", x, y);
	// format specifier %d is matched with x
	// format specifier %f is matched with y

	//x = 125
	//y = 200.000000

	//When printing a short number,
	//we use the h character before the d, o, u, or x characters
	//{hd, hu, ho,hx}.
	short int n1 = -32768; // the number is SHRT_MIN
	printf("%hd\n", n1);
	printf("%d\n",  n1); // sizeof(int) >= sizeof(short int), correct use
	printf("%i\n\n",  n1); // sizeof(int) >= sizeof(short int), correct use
	//-32768
	//-32768
	//-32768

	unsigned short int n2 = 65535; // the number is USHRT_MAX
	printf("%hu\n",  n2);
	printf("%ho\n",  n2);
	printf("%hx\n\n",  n2);
	//65535
	//177777
	//ffff

	int n3 = -2147483648;        // the number is INT_MIN
	printf("%d\n", n3);
	printf("%i\n\n", n3);
	//-2147483648
	//-2147483648

	unsigned int n4 = 4294967295; // the number is UINT_MAX
	printf("%u\n", n4);
	printf("%o\n", n4);
	printf("%x\n\n", n4);
	//4294967295
	//37777777777
	//ffffffff

	//When printing a long number,
	//we use the h character before the d, o, u, or x characters
	//{ld, lu, lo,lx}.
	long int n5 = -2147483648 ; // the number is LONG_MIN
	// It can be -9223372036854775808 as -2^63 if sizeof(long int)==8
	// but for my computer it is 4, -2147483648 is the  LONG_MIN
	printf("%ld\n", n5);
	printf("%d\n",  n5);  // use only when sizeof(int) == sizeof(long int), correct use in this computer.
	printf("%i\n\n",  n5); // use only when sizeof(int) == sizeof(long int), correct use in this computer.
	//-2147483648
	//-2147483648
	//-2147483648

	unsigned long int n6 = 4294967295; // the number is ULONG_MAX
	// It can be 18446744073709551615 as 2^64-1 if sizeof(long int) == 8
	// but for my computer it is 4, 4294967295 is the  ULONG_MAX.
	printf("%lu\n",  n6);
	printf("%lo\n",  n6);
	printf("%lx\n\n",  n6);

	// for n6 = 4294967296 (ULONG_MAX+1), printf() displays 0.
	//4294967295
	//37777777777
	//ffffffff

    printf("\nfor the following codes compiler give incorrect output when used for this computer\n");
    printf("for this computer long int holds 4 bytes, not 8 bytes. that is the reason\n");

	printf("%d  %d  %d\n", sizeof(short int), sizeof(int), sizeof(long int));
	long int n7 = -9223372036854775808 ;
	// if we assume long int hold 8 bytes !! (it does not)
	// the number is supposedly LONG_MIN for 8 byte long int

	printf("%ld\n", n7); //  0, {not correct, the number is not in the range}
	// %d and %i cannot be used when sizeof(int) != sizeof(long int)
	printf("%d\n",  n7); // 0 , {not correct, the number is not in the range}
	printf("%i\n\n",  n7); // 0, {not correct, the number is not in the range}

	unsigned long int n8 = 18446744073709551615;
	// if we assume long int hold 8 bytes !! (it does not)
	// the number is supposedly ULONG_MAX for 8 byte long int
	printf("%lu\n",  n8); // 4294967295
	//{not correct, the number is not in the range}
	printf("%lo\n",  n8); // 37777777777
	//{not correct, the number is not in the range}
	printf("%lx\n\n",  n8); // ffffffff
	//{not correct, the number is not in the range}



	// now check printf_scanf2.c

}


//NOTES***************************************//

/*
printf is actually a function with very detailed features.
printf writes the characters within quotation marks to the screen.
However, it does not print the % characters it encounters within the quotation marks.
The printf function interprets the % characters along with the character next to them as format specifiers.
The format specifiers are matched one-to-one with the parameters written after the quotation marks

*/


/*

%d	Writes int type in decimal system.
%i	Writes int type in decimal system.
%ld	Writes long type in decimal system.
%hd	Writes short type in decimal system.
%x	Writes unsigned int type in hexadecimal system.
%X	Writes unsigned int type in hexadecimal system (symbols in uppercase).
%lx	Writes unsigned long type in hexadecimal system.
%u	Writes unsigned int type in decimal system.
%o	Writes unsigned int type in octal system.
%f	Writes float and double types in decimal system.
%lf	Writes double type in decimal system.
%e	Writes real numbers in exponential format.
%c	Prints char or int type as a character representation.
%s	Prints as a string.
%Lf	Writes long double type in decimal system.
*/




