
//switch_case.c
// this file is about switch case structures and random number generation

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int dayofyear(int day, int month, int year);
void randomdate(void);
void dispdate(int day, int month, int year);

void switch_case()
{
	printf("\n-----switch_case\n");
	//--------------------------
	//test the function randomdate() that generates and displays a random date between 01.01.1923 and 31.12.2000
	int n = 20;
	srand(time(NULL));
	while (n-- > 0) {
		randomdate();
		putchar('\n');
	}


	//--------------------------
	//test the function dayofyear() that determines which day of the year a given date (day, month, year) is
	n = 2;
 	int day, month, year;

	while (n-- > 0)
	{
		printf("\nEnter a date as day month year: ");
		scanf("%d%d%d", &day, &month, &year);
		printf("It is the %dth day of the year %d.\n", dayofyear(day, month, year), year);
	}

	//--------------------------
	//test the function dispdate() that displays a given date on the screen in English format (e.g., 15th Aug. 2000)
	n = 2;
	while (n-- > 0)
	{
		printf("\nEnter a date as day month year: ");
		scanf("%d%d%d", &day, &month, &year);
		dispdate(day, month, year);
		putchar('\n');

	}

	return 0;
}


// A function that generates and displays a random date between 01.01.1923 and 31.12.2000
void randomdate(void) // assuming the input values are reasonable. there is no check of the correctness of the input !
{
	int day, month, year;
	int monthdays;

	year = rand() % 78 + 1923;
	month = rand() % 12 + 1;

	switch (month) {
		case 4:
		case 6:
		case 9:
		case 11: monthdays = 30; break;
		case 2: monthdays = isleap(year) ? 29 : 28; break;
		default : monthdays = 31;
	}
	day = rand() % monthdays + 1;

	printf("%02d - %02d - %d", day, month, year);
}


//A function that determines which day of the year a given date (day, month, year) is
int dayofyear(int day, int month, int year) 	// assuming the input values are reasonable. there is no check of the correctness of the input !
{

	int yearday = day;

	switch (month - 1) {
		case 11: yearday += 30;
		case 10: yearday += 31;
		case 9 : yearday += 30;
		case 8 : yearday += 31;
		case 7 : yearday += 31;
		case 6 : yearday += 30;
		case 5 : yearday += 31;
		case 4 : yearday += 30;
		case 3 : yearday += 31;
		case 2 : yearday += isleap(year) ? 29 : 28;
		case 1 : yearday += 31;
	}
	return yearday;
}

//A function that displays a given date on the screen in English format (e.g., 15th Aug. 2000)
void dispdate(int day, int month, int year) // assuming the input values are reasonable. there is no check of the correctness of the input !
{
	printf("%2d", day);

	switch (day) {
		case 1  :
		case 21:
		case 31: printf("st "); break;
		case 2  :
		case 22: printf("nd "); break;
		case 3  :
		case 23: printf("rd "); break;
		default  : printf("th ");
	}

	switch (month) {
		case 1 : printf("Jan "); break;
		case 2 : printf("Feb "); break;
		case 3 : printf("Mar "); break;
		case 4 : printf("Apr "); break;
		case 5 : printf("May "); break;
		case 6 : printf("Jun "); break;
		case 7 : printf("Jul "); break;
		case 8 : printf("Aug "); break;
		case 9 : printf("Sep "); break;
		case 10: printf("Oct "); break;
		case 11: printf("Nov "); break;
		case 12: printf("Dec ");
	}
	printf("%d", year);
}


int isleap(int year)
{
	if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0)
		return year;
	return 0;
}
