#include <stdio.h>
// type_conversions.c
// this file is about automatic type conversions

double product(double num1, double num2);
double addition (int param1, int param2);

void type_conversions()
{
	printf("\n-----type_conversions\n");
	//	There are four cases where an automatic type conversion will definitely occur:

	//	1- If the operands of an arithmetic or logical expression are not of the same type:
	// In this case, the type conversions performed are called general arithmetic type conversions.
	int x=7, y=3;
	float fl=0.45f;

	if (fl * x / y - 1)
		printf("\nthese expression will not be zero\n\n"); // this will be displayed
		// (0.45f * 7) -> 3.15f    |
		// (3.5f / 2 ) -> 1.575f
		// (1.575f -1 ) -> 0.575f | this is not zero
	else
		printf ("\nthese expression will  be zero\n\n");

	// 2 - When the assignment operator is used, if the right side of the assignment operator is not the same type as the left side:
	double result;
	long num1=15, num2=12;

	result = num1 + num2;
	printf("%lf\n", result);
	// The type conversions performed in this case are called assignment type conversions.

	// 3 - When a function is called, if the type of an argument used is not the same as the corresponding parameter variable of the function:

	result = product(num1, num2);
	printf("%lf\n", result);

	//4 If there is a difference between the type of a return expression and the return type of the function:
	printf("%lf\n", product( num1,  num2));


}

double product(double num1, double num2) // if the values for num1 and num2 are int type they will be converted to double
{
	return num1 * num2;
}

double addition (int param1, int param2)
{
    return (param1 + param2);
    // param1 + param2 is int type, but function returns a double type value. There is an automatic conversion for this
}


/*
operand 1			operand 2
long double	       	double, float, unsigned long, long, int, unsigned int	The 2nd operand will be converted to long double.
double				float, unsigned long, long, int, unsigned int			The 2nd operand will be converted to double.
float				unsigned long, long, int, unsigned int					The 2nd operand will be converted to float.
unsigned long		long, int, unsigned int									The 2nd operand will be converted to unsigned long.
long				int, unsigned int										The 2nd operand will be converted to long. (Note the exception!)
unsigned int		int														The 2nd operand will be converted to unsigned int.
*/
